#ifndef CLASS_DEFINE
struct affile_source
{
  struct log_source_driver super;
  struct io_fd *src;
  struct ol_string *name;
};
extern struct ol_class affile_source_class;
#endif /* !CLASS_DEFINE */

#ifndef CLASS_DECLARE
static void do_affile_source_mark(struct ol_object *o, 
void (*mark)(struct ol_object *o))
{
  struct affile_source *i = (struct affile_source *) o;
  mark((struct ol_object *) i->src);
}

static void do_affile_source_free(struct ol_object *o)
{
  struct affile_source *i = (struct affile_source *) o;
  ol_string_free(i->name);
}

struct ol_class affile_source_class =
{ STATIC_HEADER,
  &log_source_driver_class, "affile_source", sizeof(struct affile_source),
  do_affile_source_mark,
  do_affile_source_free
};
#endif /* !CLASS_DECLARE */

#ifndef CLASS_DEFINE
struct affile_dest
{
  struct log_dest_driver super;
  struct ol_string *name;
  int flags;
  struct io_fd *dest;
  struct abstract_buffer *dest_buf;
  UINT32 sync_freq;
};
extern struct ol_class affile_dest_class;
#endif /* !CLASS_DEFINE */

#ifndef CLASS_DECLARE
static void do_affile_dest_mark(struct ol_object *o, 
void (*mark)(struct ol_object *o))
{
  struct affile_dest *i = (struct affile_dest *) o;
  mark((struct ol_object *) i->dest);
  mark((struct ol_object *) i->dest_buf);
}

static void do_affile_dest_free(struct ol_object *o)
{
  struct affile_dest *i = (struct affile_dest *) o;
  ol_string_free(i->name);
}

struct ol_class affile_dest_class =
{ STATIC_HEADER,
  &log_dest_driver_class, "affile_dest", sizeof(struct affile_dest),
  do_affile_dest_mark,
  do_affile_dest_free
};
#endif /* !CLASS_DECLARE */

